﻿/*
CSA Actions
$URL: https://svn.rsm.cloud/repos/NonClient/CSA_iPart/trunk/CSA/resources/CSA.ActionService.js $
$Rev: 12379 $
$Date: 2017-11-14 18:50:02 -0600 (Tue, 14 Nov 2017) $
*/

(function (CSA) {
	/* Adjust this constant to control time before messages disappear */
	var messageTimeout = 5000;
	var actionInProgress = 0;
	var redirectTo = "";

	function doRedirect() {
		if (redirectTo !== "") {
			window.location.href = redirectTo;
		}
		actionInProgress = 0;
	}

	function doMessage(s) {
		jQuery.jGrowl(s, { life: messageTimeout });
	}

	CSA.doZoom = function (e, obj) {
		if (e.stopPropagation)
		{
			e.stopPropagation();
		} else {
			e.returnValue = false;
		}
		jQuery(obj).closest('.Alert').next('.reveal-modal').each(
			function () {
				jQuery(this).reveal();
			});
	};

	CSA.doAction = function (e, m, url) {
		if (e.stopPropagation)
		{
			e.stopPropagation();
		} else {
			e.returnValue = false;
		}
		if (actionInProgress === 1) {
			doMessage("Please wait for your previous action to complete.");
			return;
		}
		actionInProgress = 1;
		redirectTo = "";
		jQuery.ajax({
			type: "POST",
			url: url + "/DoAction",
			data: JSON.stringify({ "m": m }),
			dataType: "json",
			contentType: "application/json; charset=utf-8"
		}).done(function (msg) {
			if (msg.DoActionResult) {
				if (msg.DoActionResult.Status && msg.DoActionResult.Status === 1) {
					var hasMessage = 0;

					if (msg.DoActionResult.Message && msg.DoActionResult.Message.length > 0) {
						doMessage(msg.DoActionResult.Message);
						hasMessage = 1;
					}

					if (msg.DoActionResult.Link && msg.DoActionResult.Link.length > 0) {
						redirectTo = msg.DoActionResult.Link;
					}
					else if (msg.DoActionResult.Reload === true) {
						redirectTo = window.location.href;
					}

					if (hasMessage === 1) {
						setTimeout(doRedirect, messageTimeout);
					}
					else {
						doRedirect();
					}
				}
				else {
					if (msg.DoActionResult.Message && msg.DoActionResult.Message.length > 0) {
						doMessage(msg.DoActionResult.Message);
					}
					else {
						doMessage("An unrecognized error occurred<br/>performing your action.");
					}
					actionInProgress = 0;
				}
			}
		}).fail(function (jqXHR, textStatus, errorThrown) {
			doMessage(errorThrown);
			actionInProgress = 0;
		});
	};
} (window.CSA = window.CSA || {}));
